import { Graph } from "./graph";
import { SerializableItem } from "../serializableitem";

export class GraphElement<JSONType, HistoryType> extends SerializableItem<
    JSONType,
    HistoryType
> {
    public graph: Graph;

    constructor(id = -1, graph: Graph = undefined) {
        super(id);
        this.graph = graph;
    }

    /**
     * Removes element from its parent graph.
     * @returns True, if successful.
     */
    public delete() {
        throw new Error('Function "delete()" has not been implemented.');
    }

    public isInitialized(): boolean {
        return this.id != -1;
    }

    public toString(): string {
        throw new Error('Function "toString()" has not been implemented.');
    }

    /**
     * Compares two objects. Can be a custom implementation.
     * @returns True, if given object is identical.
     */
    public equals(other: GraphElement<JSONType, HistoryType>): boolean {
        return other.constructor == this.constructor && other.id == this.id;
    }
}
